//	
//	_CAOx[X Win32vO
//	CheckComPort.cpp
//	  2015-01-15  0.10  ... vg^Cv
//    2015-01-28  0.20  ... ListView\ɕύXD
//
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

#include <Setupapi.h>
#include "resource.h"

#pragma comment(lib, "Setupapi.lib")

#define THIS_CLASS_NAME	TEXT("CheckComPortClass")
#define THIS_APP_NAME	TEXT("CheckComPortApp")

#define PORT_NUM_MAX		100
#define COMPORT_BUFSIZE		16
#define COMDEV_BUFSIZE		64
#define	CLIPBOARD_BUFSIZE	2048

// ֐̃vg^Cv錾
void ListupCommPort(HWND hLv);
void ListupFileOpenMethod(HWND hLv);
void ListupQueryDosDevice(HWND hLv);

void InitListView(HWND hLv);
void CopyToClipBoard(HWND hLv);

// O[oϐ
HWND        _hDlg = NULL;			//C_CAOnh
HINSTANCE   _hInst = NULL;			//CX^Xnh

// ------------------------------------------------------------------------
//  C_CAOvV[W
// ------------------------------------------------------------------------
LRESULT CALLBACK DlgProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	static HWND	hLv = NULL;			// ListView EBhEnh
	
	switch (uMessage) {
    case WM_INITDIALOG:
		hLv = GetDlgItem(hWnd, IDC_LV_COMPORT);
		InitListView(hLv);
		break;
        
    case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			break;					// Do Nothing
		case IDCANCEL:
            DestroyWindow(hWnd);
            break;
        case IDC_BUTTON_CLOSE:
			DestroyWindow(hWnd);
			break;
        case IDC_BUTTON_CHECK:
			ListupCommPort(hLv);
			break;
		case IDC_BUTTON_CHECK2:
			ListupQueryDosDevice(hLv);
			break;
		case IDC_BUTTON_CHECK3:
			ListupFileOpenMethod(hLv);
			break;
		case IDC_BUTTON_TOCLIP:
			CopyToClipBoard(hLv);
			break;
        default:
            return DefWindowProc(hWnd, uMessage, wParam, lParam);
        }
        break;
        
    case WM_CLOSE:
		DestroyWindow(hWnd);
		break;
    
    case WM_DESTROY:
        PostQuitMessage(0);
        break;

    default:
        return DefWindowProc(hWnd, uMessage, wParam, lParam);
    }
    
    return 0;
}

// ------------------------------------------------------------------------
//  WinMain
// ------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpszCmdLine, int nCmdShow)
{
    MSG             msg;
    WNDCLASS        wc;
    
    _hInst = hInst;

    //CEChENX̓o^
    wc.style         = 0;
    wc.lpfnWndProc   = DlgProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = DLGWINDOWEXTRA;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = THIS_CLASS_NAME;
    if (RegisterClass(&wc) == 0) {
        MessageBox(NULL, TEXT("EChENXo^ł܂ł"),
		            THIS_APP_NAME, MB_APPLMODAL | MB_ICONSTOP);
        return FALSE;
    }
    
    //CEChE̐
    if((_hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAINDIALOG), 0, (DLGPROC)DlgProc)) == NULL) {
        MessageBox(NULL, TEXT("CEChE쐬ł܂ł"),
	                THIS_APP_NAME, MB_APPLMODAL | MB_ICONSTOP);
        return FALSE;
    }
    
    //CEChE̕\
    ShowWindow(_hDlg, nCmdShow);
    UpdateWindow(_hDlg);

    //bZ[W[v
    while(GetMessage(&msg, NULL, 0, 0)) {
        if(IsDialogMessage(_hDlg, &msg) == FALSE) {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    return (int)msg.wParam;
}

static void ListupCommPort(HWND hLv)
{
	GUID		ClassGuid[1];
	HDEVINFO	hDevInfo = NULL;
	SP_DEVINFO_DATA		DevInfoData;

	DWORD	dwReqSize, dwMbrIndex;

	DevInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
	if (!SetupDiClassGuidsFromName(TEXT("PORTS"), (LPGUID)&ClassGuid, 1, &dwReqSize)) goto CLEANUP;

	ListView_DeleteAllItems(hLv);

	hDevInfo =	SetupDiGetClassDevs(&ClassGuid[0], NULL, NULL, DIGCF_PRESENT | DIGCF_PROFILE);
	if (hDevInfo) {
		dwMbrIndex = 0;
		while (SetupDiEnumDeviceInfo(hDevInfo, dwMbrIndex++, &DevInfoData)) {
			TCHAR szFriendlyName[MAX_PATH], szPortName[MAX_PATH];
			DWORD dwPropType, dwReqSize = 0;

			BOOL bRet = SetupDiGetDeviceRegistryProperty(hDevInfo, &DevInfoData, SPDRP_FRIENDLYNAME,
												   &dwPropType, (LPBYTE)szFriendlyName, sizeof(szFriendlyName), &dwReqSize);
			HKEY hKey = SetupDiOpenDevRegKey(hDevInfo, &DevInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_READ);
			if (hKey) {
				DWORD dwType = REG_SZ;
				dwReqSize = sizeof(szPortName);
				long lRet = RegQueryValueEx(hKey, TEXT("PortName"), 0, &dwType, (LPBYTE)&szPortName, &dwReqSize);
				RegCloseKey(hKey);
			}
			if (_tcsnicmp(szPortName, TEXT("COM"), 3) == 0) {  // COM|[ghCo𔭌
				TCHAR szDeviceName[COMDEV_BUFSIZE];
				if (!QueryDosDevice(szPortName, szDeviceName, COMDEV_BUFSIZE)) {
					szDeviceName[0] = '\0';
				}
			// COM|[gtւ\tgɑΉ 2015-01-22
			// FriendlyName ̍Ō (COMn)  COM|[g擾
			//	int iPort = _tstoi(&szPortName[3]);
				int iPort = _tstoi(_tcsstr(szFriendlyName, TEXT("(COM")) + 4);

			// Port Open Check
				TCHAR szPort[COMPORT_BUFSIZE];
			    _stprintf_s(szPort, COMPORT_BUFSIZE, TEXT("\\\\.\\COM%d"), iPort);	// COM10ȏɑΉ
				HANDLE	hComm = CreateFile(szPort, GENERIC_READ, 0, NULL,
										OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
				CloseHandle(hComm);
				int iStat = (hComm == INVALID_HANDLE_VALUE) ? 0 : 1;

			// ListViewItemo^
				LVITEM lvi;
				ZeroMemory(&lvi, sizeof(LVITEM));

				lvi.iItem = dwMbrIndex - 1;
				lvi.mask = LVIF_TEXT;
				lvi.pszText = szPortName;
				ListView_InsertItem(hLv, &lvi);

				lvi.iSubItem = 1;
				//lvi.pszText = (iStat) ? TEXT("") : TEXT("~");
				lvi.pszText = (iStat) ? TEXT("OK") : TEXT("-");
				ListView_SetItem(hLv, &lvi);

				lvi.iSubItem = 2;
				lvi.pszText = szFriendlyName;
				ListView_SetItem(hLv, &lvi);

				lvi.iSubItem = 3;
				lvi.pszText = szDeviceName;
				ListView_SetItem(hLv, &lvi);
			}
		}
	}
CLEANUP:
	SetupDiDestroyDeviceInfoList(hDevInfo);
}

void ListupQueryDosDevice(HWND hLv)
{
	ListView_DeleteAllItems(hLv);

	TCHAR szDeviceName[COMDEV_BUFSIZE];
	ZeroMemory(szDeviceName, COMDEV_BUFSIZE * sizeof(TCHAR));

	// COM|[g DOS̃foCXꗗ擾
	TCHAR szPort[COMPORT_BUFSIZE];
	int iRows = 0;
	for (int i = 1; i < PORT_NUM_MAX; i++) {	// COM1 - COM99܂Ń`FbN
		_stprintf_s(szPort, COMPORT_BUFSIZE, TEXT("COM%d"), i);
		if  (QueryDosDevice(szPort, szDeviceName, COMDEV_BUFSIZE)) {
			LVITEM lvi;
			ZeroMemory(&lvi, sizeof(LVITEM));

			lvi.iItem = iRows++;
			lvi.mask = LVIF_TEXT;
			lvi.pszText = szPort;
			ListView_InsertItem(hLv, &lvi);

			lvi.iSubItem = 3;
			lvi.pszText = szDeviceName;
			ListView_SetItem(hLv, &lvi);
		}
	}
	return;
}

void ListupFileOpenMethod(HWND hLv)
{
	ListView_DeleteAllItems(hLv);

	int iRows = 0;
	for (int i = 1; i < PORT_NUM_MAX; i++) {	// COM1 - COM99܂Ń`FbN
		TCHAR szPort[16];
		_stprintf_s(szPort, 16, TEXT("\\\\.\\COM%d"), i);		// COM10ȏɑΉ
		HANDLE	hComm = CreateFile(szPort, GENERIC_READ, 0, NULL,
								OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		CloseHandle(hComm);
		if (hComm != INVALID_HANDLE_VALUE) {
			LVITEM lvi;
			ZeroMemory(&lvi, sizeof(LVITEM));

			lvi.iItem = iRows++;
			lvi.mask = LVIF_TEXT;
			lvi.pszText = szPort;
			ListView_InsertItem(hLv, &lvi);

			lvi.iSubItem = 1;
			lvi.pszText = TEXT("OK");
			ListView_SetItem(hLv, &lvi);
		}
	}
	return;
}

void InitListView(HWND hLv)
{
	if (hLv == NULL) return;

	// ListView  FullRowSelectɃZbg
    DWORD dwStyle = ListView_GetExtendedListViewStyle(hLv);
    dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES; // | LVS_EX_CHECKBOXES | LVS_EX_HEADERDRAGDROP;
    ListView_SetExtendedListViewStyle(hLv, dwStyle);

	// wb_ڂ̐ݒ
	LVCOLUMN lvc;
	ZeroMemory(&lvc, sizeof(LVCOLUMN));

	lvc.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 80;
	lvc.pszText = TEXT("COM No.");
	ListView_InsertColumn(hLv, 0, &lvc);

	lvc.cx = 40;
	lvc.pszText = TEXT("Stat");
	ListView_InsertColumn(hLv, 1, &lvc);

	lvc.cx = 160;
	lvc.pszText = TEXT("Friendly Name");
	ListView_InsertColumn(hLv, 2, &lvc);

	lvc.cx = 160;
	lvc.pszText = TEXT("Device Name");
	ListView_InsertColumn(hLv, 3, &lvc);
}

void CopyToClipBoard(HWND hLv)
{
	// ListView Contents to ClipBoard
	if (!OpenClipboard(_hDlg)) {
		MessageBox(NULL, TEXT("Nbv{[hgpł܂"), TEXT("G["), MB_OK | MB_ICONINFORMATION);
		return;
	}
	if (!EmptyClipboard()) {
		MessageBox(NULL, TEXT("Nbv{[hNAł܂"), TEXT("G["), MB_OK | MB_ICONINFORMATION);
		return;
	}

	// Clipboard p̃obt@GALɊm
	HGLOBAL hMem = GlobalAlloc(GMEM_FIXED, CLIPBOARD_BUFSIZE * sizeof(TCHAR));
	LPTSTR lpBuf = (LPTSTR)hMem;
	int	iOffs = 0;

	// Xgr[eڂ̎擾pobt@
	TCHAR b0[32], b1[32], b2[64], b3[64];

	int iCount = ListView_GetItemCount(hLv);
	for (int i = 0; i < iCount; i++) {
		ListView_GetItemText(hLv, i, 0, b0, 32);
		ListView_GetItemText(hLv, i, 1, b1, 32);
		ListView_GetItemText(hLv, i, 2, b2, 64);
		ListView_GetItemText(hLv, i, 3, b3, 64);

		int iChrs = _stprintf_s(lpBuf + iOffs, CLIPBOARD_BUFSIZE - iOffs - 2,
									TEXT("%d,%s,%s,%s,%s\r\n"), i, b0, b1, b2, b3);
		if (iChrs < 0) {
			MessageBox(NULL, TEXT("]I[o[܂"), TEXT("]mF"), MB_OK | MB_ICONSTOP);
			break;
		}
		iOffs += iChrs;		// i[obt@ʒui߂
	}
	// L[TCYœK ...  { I[NULL
	hMem = GlobalReAlloc(hMem, (iOffs + 1) * sizeof(TCHAR), GMEM_MOVEABLE);

	UINT uFormat;
#ifdef _UNICODE
	uFormat = CF_UNICODETEXT;
#else
	uFormat = CF_TEXT;
#endif
	if (SetClipboardData(uFormat, hMem) == NULL) {
		CloseClipboard();
		GlobalFree(hMem);
		MessageBox(NULL, TEXT("Nbv{[hɃf[^Rs[ł܂ł"), 
					TEXT("G["), MB_OK | MB_ICONSTOP);
		return;
	}
	CloseClipboard();

	MessageBox(NULL, TEXT("Nbv{[hɃf[^Rs[܂"),
					TEXT("ImF"), MB_OK | MB_ICONINFORMATION);
	return;
}